Subject: Re: [syzbot] WARNING in remove_proc_entry (3)

From: "J. Bruce Fields" <[email-masked]>
Date: Mon, 2 Aug 2021 18:27:06 -0400

On Sat, Jul 17, 2021 at 10:02:20AM -0700, syzbot wrote:
> Hello,
> 
> syzbot found the following issue on:
> 
> HEAD commit:    7fef2edf7cc7 sd: don't mess with SD_MINORS for CONFIG_DEBU..
> git tree:       upstream
> console output: https://syzkaller.appspot.com/x/log.txt?x=147c3b3c300000
> kernel config:  https://syzkaller.appspot.com/x/.config?x=957eaf08bd3bb8d6
> dashboard link: https://syzkaller.appspot.com/bug?extid=3405f46cf7078134383e
> 
> Unfortunately, I don't have any reproducer for this issue yet.
> 
> IMPORTANT: if you fix the issue, please add the following tag to the commit:
> Reported-by: [email-masked]
> 
> bond0 (unregistering): (slave bond_slave_0): Releasing backup interface
> bond0 (unregistering): Released all slaves
> ------------[ cut here ]------------
> name 'use-gss-proxy'
> WARNING: CPU: 0 PID: 7951 at fs/proc/generic.c:709 remove_proc_entry+0x389/0x460 fs/proc/generic.c:709

I'm probably missing something obvious.  This says we're calling
remove_proc_entry on a name that doesn't exist.

We're doing that removal from a pernet_operations ->exit method.  As I
understand, those won't get called unless the corresponding ->init
succeeds, but that means the proc entry was created.

There's a bug in gss_svc_init_net that has an extra unnecessary call,
but I'm not seeing how we hit that case there either.  Hm.

--b.

> Modules linked in:
> CPU: 0 PID: 7951 Comm: kworker/u4:2 Tainted: G        W         5.14.0-rc1-syzkaller #0
> Hardware name: Google Google Compute Engine/Google Compute Engine, BIOS Google 01/01/2011
> Workqueue: netns cleanup_net
> RIP: 0010:remove_proc_entry+0x389/0x460 fs/proc/generic.c:709
> Code: e9 6d fe ff ff e8 f7 d9 85 ff 48 c7 c7 20 d4 b3 8b e8 fb 96 3d 07 e8 e6 d9 85 ff 4c 89 e6 48 c7 c7 00 2a 9c 89 e8 92 86 f8 06 <0f> 0b e9 a4 fe ff ff e8 cb d9 85 ff 48 8d bd d8 00 00 00 48 b8 00
> RSP: 0018:ffffc9000c8efb48 EFLAGS: 00010286
> RAX: 0000000000000000 RBX: 1ffff9200191df6b RCX: 0000000000000000
> RDX: ffff8880341121c0 RSI: ffffffff815c9ca5 RDI: fffff5200191df5b
> RBP: 0000000000000000 R08: 0000000000000000 R09: 0000000000000000
> R10: ffffffff815c3aae R11: 0000000000000000 R12: ffffffff8aa28e40
> R13: dffffc0000000000 R14: ffff888000102000 R15: 0000000000000001
> FS:  0000000000000000(0000) GS:ffff8880b9c00000(0000) knlGS:0000000000000000
> CS:  0010 DS: 0000 ES: 0000 CR0: 0000000080050033
> CR2: 00007f38761a8740 CR3: 000000002c23a000 CR4: 00000000001506f0
> DR0: 0000000000000000 DR1: 0000000000000000 DR2: 0000000000000000
> DR3: 0000000000000000 DR6: 00000000fffe0ff0 DR7: 0000000000000600
> Call Trace:
>  destroy_use_gss_proxy_proc_entry net/sunrpc/auth_gss/svcauth_gss.c:1504 [inline]
>  gss_svc_shutdown_net+0x196/0x8c0 net/sunrpc/auth_gss/svcauth_gss.c:1992
>  ops_exit_list+0xb0/0x160 net/core/net_namespace.c:175
>  cleanup_net+0x4ea/0xb10 net/core/net_namespace.c:595
>  process_one_work+0x98d/0x1630 kernel/workqueue.c:2276
>  worker_thread+0x658/0x11f0 kernel/workqueue.c:2422
>  kthread+0x3e5/0x4d0 kernel/kthread.c:319
>  ret_from_fork+0x1f/0x30 arch/x86/entry/entry_64.S:295
> 
> 
> ---
> This report is generated by a bot. It may contain errors.
> See https://goo.gl/tpsmEJ for more information about syzbot.
> syzbot engineers can be reached at [email-masked].
> 
> syzbot will keep track of this issue. See:
> https://goo.gl/tpsmEJ#status for how to communicate with syzbot.